helm/bin/mov2gif

75 lines
1.8 KiB
Plaintext
Raw Normal View History

#!/usr/bin/env bash
2016-05-31 21:26:43 -07:00
2017-05-10 01:25:11 -07:00
# Uses ffmpeg to convert a video file to a gif file. Optimizes the final result
# with gifsicle.
#
# Requires: ffmpeg
# Optional: gifsicle
#
# Example:
# vid2gif some-vid.mp4 output.gif
# vid2gif -f 10 -s 00:00:10 -t 00:00:05 some-vid.mp4 output.gif
2017-05-10 01:25:11 -07:00
set -e
PALETTE="/tmp/palette.png"
usage() {
cat <<EOL
Usage: ${0##*/} [-fsSth] SOURCE_FILE [destfile]
2017-05-10 01:25:11 -07:00
-f [FPS] set frames per second
-s [hh:mm:ss] set starting time (like -ss in ffmpeg)
-S [W:H] set width/height (either can be -1 for auto)
2017-05-10 01:25:11 -07:00
-t [hh:mm:ss] set the duration to capture (like -t in ffmpeg)
-h this help
EOL
}
2016-05-31 21:26:43 -07:00
2017-05-10 01:25:11 -07:00
cleanup() { rm -f "$PALETTE"; }
trap cleanup EXIT
#
fps=30
while getopts hf:s:t:S: opt; do
2016-11-10 09:39:08 -08:00
case $opt in
2017-05-10 01:25:11 -07:00
f) fps="$OPTARG" ;;
s) start="-ss $OPTARG" ;;
S) scale=",scale=$OPTARG:flags=lanczos" ;;
2017-05-10 01:25:11 -07:00
t) duration="-t $OPTARG" ;;
h) usage
exit
;;
2017-05-10 01:25:11 -07:00
:) >&2 echo "$OPTARG requires an argument"
usage
exit 1
;;
*) >&2 echo "Not a valid arg: $opt"
usage
exit 1
;;
esac
done
2017-05-10 01:25:11 -07:00
shift $((OPTIND-1))
#
if (($# == 0)); then
>&2 echo "No movie file specified"
exit
elif [[ ! -f $1 ]]; then
>&2 echo "$1 does not exist"
exit
fi
2017-05-10 01:25:11 -07:00
src="$1"
dest="${2:-${src%.*}.gif}"
flags="fps=${fps}$scale"
2016-05-31 21:26:43 -07:00
2017-05-10 01:25:11 -07:00
# stats_mode=full favors motion, causing the resulting palette to better
# accomodate fades and transitions.
ffmpeg -v warning $start $duration -i "$src" -vf "$flags,palettegen=stats_mode=full" -y "$PALETTE"
ffmpeg -v warning $start $duration -i "$src" -i "$PALETTE" -lavfi "$flags [x]; [x][1:v] paletteuse" -y "$dest"
2016-05-31 21:26:43 -07:00
2017-05-10 01:25:11 -07:00
if command -v gifsicle >/dev/null; then
gifsicle -O3 "$dest" -o "$dest"
fi